/*
 * Copyright (C) 2024 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.android.sdklib.repository.generated.sysimg.v4;

import com.android.repository.impl.meta.TrimStringAdapter;
import com.android.sdklib.repository.IdDisplay;
import com.android.sdklib.repository.generated.common.v3.ApiDetailsType;
import com.android.sdklib.repository.generated.common.v3.IdDisplayType;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;

/**
 * DO NOT EDIT This file was generated by xjc from sdk-sys-img-04.xsd. Any changes will be lost upon
 * recompilation of the schema. See the schema file for instructions on running xjc.
 *
 * <p>type-details subclass including system image-specific information: - tag, specifying the
 * device type (tablet, tv, wear, etc.) - vendor, the vendor for this system image (android, google,
 * etc.) - abi, the architecture for this image (x86, armeabi-v7a, etc.)
 *
 * <p>Java class for sysImgDetailsType complex type.
 *
 * <p>The following schema fragment specifies the expected content contained within this class.
 *
 * <pre>
 * &lt;complexType name="sysImgDetailsType"&gt;
 *   &lt;complexContent&gt;
 *     &lt;extension base="{http://schemas.android.com/sdk/android/repo/common/03}apiDetailsType"&gt;
 *       &lt;sequence&gt;
 *         &lt;element name="tag" type="{http://schemas.android.com/sdk/android/repo/common/03}idDisplayType" maxOccurs="unbounded" minOccurs="0"/&gt;
 *         &lt;element name="vendor" type="{http://schemas.android.com/sdk/android/repo/common/03}idDisplayType" minOccurs="0"/&gt;
 *         &lt;element name="abi" type="{http://schemas.android.com/sdk/android/repo/sys-img2/04}abiType" minOccurs="0"/&gt;
 *         &lt;element name="abis" type="{http://schemas.android.com/sdk/android/repo/sys-img2/04}abiType" maxOccurs="unbounded"/&gt;
 *         &lt;element name="translatedAbis" type="{http://schemas.android.com/sdk/android/repo/sys-img2/04}abiType" maxOccurs="unbounded" minOccurs="0"/&gt;
 *       &lt;/sequence&gt;
 *     &lt;/extension&gt;
 *   &lt;/complexContent&gt;
 * &lt;/complexType&gt;
 * </pre>
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(
        name = "sysImgDetailsType",
        propOrder = {"tags", "vendor", "abi", "abis", "translatedAbis"})
@SuppressWarnings({"override", "unchecked"})
public class SysImgDetailsType extends ApiDetailsType
        implements com.android.sdklib.repository.meta.DetailsTypes.SysImgDetailsType {

    @XmlElement(name = "tag")
    protected List<IdDisplayType> tags;
    protected IdDisplayType vendor;

    @XmlJavaTypeAdapter(TrimStringAdapter.class)
    protected String abi;

    @XmlElement(required = true)
    @XmlJavaTypeAdapter(TrimStringAdapter.class)
    protected List<String> abis;
    @XmlJavaTypeAdapter(TrimStringAdapter.class)
    protected List<String> translatedAbis;

    /**
     * Gets the value of the tags property.
     *
     * <p>This accessor method returns a reference to the live list, not a snapshot. Therefore any
     * modification you make to the returned list will be present inside the JAXB object. This is
     * why there is not a <CODE>set</CODE> method for the tags property.
     *
     * <p>For example, to add a new item, do as follows:
     *
     * <pre>
     *    getTags().add(newItem);
     * </pre>
     *
     * <p>Objects of the following type(s) are allowed in the list {@link IdDisplayType }
     */
    public List<IdDisplayType> getTagsInternal() {
        if (tags == null) {
            tags = new ArrayList<IdDisplayType>();
        }
        return this.tags;
    }

    /**
     * Gets the value of the vendor property.
     *
     * @return possible object is {@link IdDisplayType }
     */
    public IdDisplayType getVendor() {
        return vendor;
    }

    /**
     * Sets the value of the vendor property.
     *
     * @param value allowed object is {@link IdDisplayType }
     */
    public void setVendorInternal(IdDisplayType value) {
        this.vendor = value;
    }

    /**
     * Gets the value of the abi property.
     *
     * @return possible object is {@link String }
     */
    public String getAbi() {
        return abi;
    }

    /**
     * Sets the value of the abi property.
     *
     * @param value allowed object is {@link String }
     */
    public void setAbi(String value) {
        this.abi = value;
    }

    /**
     * Gets the value of the abis property.
     *
     * <p>This accessor method returns a reference to the live list, not a snapshot. Therefore any
     * modification you make to the returned list will be present inside the JAXB object. This is
     * why there is not a <CODE>set</CODE> method for the abis property.
     *
     * <p>For example, to add a new item, do as follows:
     *
     * <pre>
     *    getAbis().add(newItem);
     * </pre>
     *
     * <p>Objects of the following type(s) are allowed in the list {@link String }
     */
    public List<String> getAbis() {
        if (abis == null) {
            abis = new ArrayList<String>();
        }
        return this.abis;
    }

    /**
     * Gets the value of the translatedAbis property.
     *
     * <p>This accessor method returns a reference to the live list, not a snapshot. Therefore any
     * modification you make to the returned list will be present inside the JAXB object. This is
     * why there is not a <CODE>set</CODE> method for the translatedAbis property.
     *
     * <p>For example, to add a new item, do as follows:
     *
     * <pre>
     *    getTranslatedAbis().add(newItem);
     * </pre>
     *
     * <p>Objects of the following type(s) are allowed in the list {@link String }
     */
    public List<String> getTranslatedAbis() {
        if (translatedAbis == null) {
            translatedAbis = new ArrayList<String>();
        }
        return this.translatedAbis;
    }

    public boolean isValidAbi(String value) {
        return ((value == null)
                || (value.matches(
                        "^(armeabi|armeabi-v7a|arm64-v8a|x86|x86_64|mips|mips64|riscv64)$")));
    }

    public boolean isValidAbis(String value) {
        return ((value != null)
                && (value.matches(
                        "^(armeabi|armeabi-v7a|arm64-v8a|x86|x86_64|mips|mips64|riscv64)$")));
    }

    public boolean isValidTranslatedAbis(String value) {
        return ((value == null)
                || (value.matches(
                        "^(armeabi|armeabi-v7a|arm64-v8a|x86|x86_64|mips|mips64|riscv64)$")));
    }

    public List<IdDisplay> getTags() {
        return ((List) getTagsInternal());
    }

    public void setVendor(IdDisplay value) {
        setVendorInternal(((IdDisplayType) value));
    }

    public ObjectFactory createFactory() {
        return new ObjectFactory();
    }

}
